package com.example.nto.controller;

import com.example.nto.entity.Code;
import com.example.nto.entity.Employee;
import com.example.nto.service.CodeService;
import com.example.nto.service.EmployeeService;
import lombok.RequiredArgsConstructor;
import org.springframework.http.HttpStatus;
import org.springframework.web.bind.annotation.*;

import java.time.LocalDateTime;

@RestController
@RequiredArgsConstructor
@RequestMapping("/api")
public class EmployeeController {
    private final EmployeeService employeeService;
    private final CodeService codeService;

    @GetMapping("/{login}/auth")
    @ResponseStatus(HttpStatus.OK)  // Возвращаемое по умолчанию значение.
    public void verificationLogin(@PathVariable String login) {
        employeeService.get(login);
    }

    @GetMapping("/{login}/info")
    @ResponseStatus(HttpStatus.OK)
    public Employee getEmployee(@PathVariable String login) {
        return employeeService.get(login);
    }

    @PatchMapping("/{login}/open")
    @ResponseStatus(HttpStatus.OK)
    public void visit(@PathVariable String login, @RequestBody Code code) {
        codeService.getCode(code);

        Employee employee = employeeService.get(login);
        employeeService.update(employee, LocalDateTime.now());
    }
}
