package com.example.nto.service.impl;

import com.example.nto.aspect.annotation.LogExample;
import com.example.nto.entity.Code;
import com.example.nto.exception.SomethingWentWrongException;
import com.example.nto.repository.CodeRepository;
import com.example.nto.service.CodeService;
import lombok.RequiredArgsConstructor;
import org.springframework.stereotype.Service;


@Service
@RequiredArgsConstructor
public class CodeServiceImpl implements CodeService {
    // Класс отвечает за основную логику приложения. Тут мы получаем из бд и обработав их возвращаем клиенту.

    private final CodeRepository codeRepository;  // Это объект для работы с бд.

    @LogExample
    @Override
    public Code getCode(Code code) {
        // В ТЗ написано `401 - логина не существует или неверный`.
        // Вообще тут спорный момент, надо ли возвращать 401, если `Code` не существует.
        // Так что напишу здесь два варианта, авось какой-нибудь прокатит.

        // final String error_message = "QR-код с кодом " + code.getValue() + " не найден!";
        //
        // try {
        //     codeRepository.findById(code.getValue()).orElseThrow(() -> new CodeNotFoundException(error_message));
        //     return code;
        // }
        // catch (CodeNotFoundException e) { throw new CodeNotFoundException(e.getMessage()); }
        // catch (Exception e) { throw new SomethingWentWrongException("Непредвиденная ошибка"); }

        // Проверка, существует ли `Code`. Если не существует, вернётся ошибка 400.
        codeRepository.findById(code.getValue()).orElseThrow(() -> new SomethingWentWrongException("Непредвиденная ошибка"));
        return code;
    }
}
